local LDBThreat = LibStub("LibDataBroker-1.1"):NewDataObject("LDBThreat", { icon = "Interface\\TARGETINGFRAME\\UI-TargetingFrame-Skull.blp", type = "data source", text = "" })

local f = CreateFrame("Frame")

f:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE")
f:RegisterEvent("UNIT_THREAT_LIST_UPDATE")
f:RegisterEvent("PLAYER_TARGET_CHANGED")
f:RegisterEvent("PARTY_MEMBERS_CHANGED")

local Color = {green = "ff00ff00", blue = "ff00ffff", red = "ffff0000", yellow = "ffffff00", orange = "ffffa500",}

local function GetThreat(unitId, mobId)
	local _, _, _, rawthreatpct, _ = UnitDetailedThreatSituation(unitId, mobId)
	if not rawthreatpct then rawthreatpct = 0 end
	return rawthreatpct
end

local function GetThreatStatus(unitId, mobId)
	local _,status,_,_, _ = UnitDetailedThreatSituation(unitId, mobId)
	return status
end

local function GetTank(unitId, mobId)
	local isTanking,_,_,_, _ = UnitDetailedThreatSituation(unitId, mobId)
	if not isTanking then isTanking = 0 end
	return isTanking
end

local function GetClassColor(unit)
	local unitClass, _ = UnitClass(unit)
	local classColor = "ff848484" --Pets
	if unitClass == "Death Knight" then
		classColor = "ffC41F3B"
	
	elseif unitClass == "Druid" then
		classColor = "ffFF7D0A"
	
	elseif unitClass == "Hunter" then
		classColor = "ffABD473"
	
	elseif unitClass == "Mage" then
		classColor = "ff69CCF0"
	
	elseif unitClass == "Paladin" then
		classColor = "ffF58CBA"
	
	elseif unitClass == "Priest" then
		classColor = "ffFFFFFF"
	
	elseif unitClass == "Rogue" then
		classColor = "ffFFF569"
	
	elseif unitClass == "Shaman" then
		classColor = "ff2459FF"
	
	elseif unitClass == "Warlock" then
		classColor = "ff9482C9"
	
	elseif unitClass == "Warrior" then
		classColor = "ffC79C6E"
	end
	return classColor
end

local function UpdateDisplay()
	LDBThreat.text = "LDB-Threat"
	local status = nil
	local highUnit = ""
	local unitThreat = 0
	local highThreat = 0
	local tankName = nil
	local partynum = GetNumPartyMembers()
	local raidnum = GetNumRaidMembers()
	if (partynum == 0 and raidnum == 0) and UnitCanAttack("player", "target") and not(UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) -- Solo Target
	then			
		status = GetThreatStatus("player", "target")
		rawthreatpct = GetThreat("player", "target")
		if HasPetUI() then
			highThreat = GetThreat("pet", "target")
			highUnit = UnitName("pet")
			highUnitColor = GetClassColor("pet")
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum == 0 and raidnum == 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) -- Solo Target of Target
	then
		status = GetThreatStatus("player", "targettarget")
		rawthreatpct = GetThreat("player", "targettarget")			
		if HasPetUI() then
			highThreat = GetThreat("pet", "targettarget")
			highUnit = UnitName("pet")
			highUnitColor = GetClassColor("pet")
			unitTanking = GetTank("pet", "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (raidnum > 0) and UnitCanAttack("player", "target") and not (UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) --Raid Target
	then 
		status = GetThreatStatus("player", "target")
		rawthreatpct = GetThreat("player", "target")
		for i = 1, (raidnum -1) do
			unitThreat = GetThreat("raid"..i, "target") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raid"..i)
					highUnitColor = GetClassColor("raid"..i)
				end
			unitThreat = GetThreat("raidpet"..i, "target")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raidpet"..i)
					highUnitColor = GetClassColor("pet")
				end
			unitThreat = GetThreat("pet", "target")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
				end
			unitTanking = GetTank("raid"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raid"..i)
				tankName = UnitName("raid"..i)
			end
			unitTanking = GetTank("raidpet"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raidpet"..i)
				tankName = UnitName("raidpet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (raidnum > 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) --Raid Target of Target
	then
		status = GetThreatStatus("player", "targettarget")
		rawthreatpct = GetThreat("player", "targettarget")				
		for i = 1, (raidnum -1) do
			unitThreat = GetThreat("raid"..i, "targettarget") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raid"..i)
					highUnitColor = GetClassColor("raid"..i)
				end
			unitThreat = GetThreat("raidpet"..i, "targettarget")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("raidpet"..i)
					highUnitColor = GetClassColor("pet")
				end
			unitThreat = GetThreat("pet", "targettarget")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
				end
			unitTanking = GetTank("raid"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raid"..i)
				tankName = UnitName("raid"..i)
			end
			unitTanking = GetTank("raidpet"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("raidpet"..i)
				tankName = UnitName("raidpet"..i)
			end
			unitTanking = GetTank("pet", "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum > 0) and UnitCanAttack("player", "target") and not (UnitIsDead("target") or UnitIsFriend("player", "target") or UnitPlayerControlled("target")) -- Party Target
	then 
		status = GetThreatStatus("player", "target")
		rawthreatpct = GetThreat("player", "target")	
		for i = 1, partynum do
			unitThreat = GetThreat("party"..i, "target") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("party"..i)
					highUnitColor = GetClassColor("party"..i)
				end
			unitThreat = GetThreat("partypet"..i, "target")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("partypet"..i)
					highUnitColor = GetClassColor("partypet"..i)
				end
			unitThreat = GetThreat("pet", "target")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
				end
			unitTanking = GetTank("party"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("party"..i)
				tankName = UnitName("party"..i)
			end
			unitTanking = GetTank("partypet"..i, "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("partypet"..i)
				tankName = UnitName("partypet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	elseif (partynum > 0) and UnitCanAttack("player", "targettarget") and not (UnitCanAttack("player", "target") or UnitIsDead("targettarget") or UnitIsFriend("player", "targettarget") or UnitPlayerControlled("targettarget")) --Party Target of Target
	then
		status = GetThreatStatus("player", "targettarget")
		rawthreatpct = GetThreat("player", "targettarget")				
		for i = 1, partynum do
			unitThreat = GetThreat("party"..i, "targettarget") 	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("party"..i)
					highUnitColor = GetClassColor("party"..i)
				end
			unitThreat = GetThreat("partypet"..i, "targettarget")	
				if unitThreat > highThreat then 
					highThreat = unitThreat	
					highUnit = UnitName("partypet"..i)
					highUnitColor = GetClassColor("partypet"..i)
				end
			unitThreat = GetThreat("pet", "targettarget")
				if unitThreat > highThreat then
					highThreat = unitThreat
					highUnit = UnitName("pet")
					highUnitColor = GetClassColor("pet")
				end
			unitTanking = GetTank("party"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("party"..i)
				tankName = UnitName("party"..i)
			end
			unitTanking = GetTank("partypet"..i, "targettarget")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("partypet"..i)
				tankName = UnitName("partypet"..i)
			end
			unitTanking = GetTank("pet", "target")
			if unitTanking == 1 then
				unitTankingColor = GetClassColor("pet")
				tankName = UnitName("pet")
			end
		end
	end
	if status == 0
	then
		if rawthreatpct < 80
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.green, rawthreatpct )
			if tankName
			then
				LDBThreat.text = string.format("|c%sThreat: %d %% <|r |c%s%s.|r", Color.green, rawthreatpct, unitTankingColor, tankName )
			end
		end
		if rawthreatpct > 79 and rawthreatpct < 100
		then
			LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.yellow, rawthreatpct )
			if tankName
			then
				LDBThreat.text = string.format("|c%sThreat: %d %% <|r |c%s%s.|r", Color.yellow, rawthreatpct, unitTankingColor, tankName )
			end
		end
	elseif status == 1
	then
		LDBThreat.text = string.format("|c%sThreat: %d %%|r", Color.orange, rawthreatpct )
		if tankName
		then
			LDBThreat.text = string.format("|c%sThreat: %d %% >|r |c%s%s.|r", Color.orange, rawthreatpct, unitTankingColor, tankName )
		end
	elseif status == 2
	then
		LDBThreat.text = string.format("|c%s** WEAK AGGRO! **|r", Color.yellow )
		if highThreat ~= 0
		then
			threatdiff = (100 - highThreat)
			LDBThreat.text = string.format("|c%sWEAK AGGRO: %d %% >|r |c%s%s.|r", Color.yellow, threatdiff, highUnitColor, highUnit )
		end	
	elseif status == 3
	then
		LDBThreat.text = string.format("|c%s** AGGRO! **|r", Color.red )
		if highThreat ~= 0
		then
			threatdiff = (100 - highThreat)
			LDBThreat.text = string.format("|c%sAGGRO: %d %% >|r |c%s%s.|r", Color.red, threatdiff, highUnitColor, highUnit )
		end
	end
end

function LDBThreat:OnTooltipShow()
	self:AddLine("LDB-Threat |cff00ff004.3a|r")
end

f:SetScript("OnEvent", function() UpdateDisplay() end )